Ended core 5 and started core 6
[ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
06209efc 20# Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
06209efc
MT
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
7c0736aa 27VERSION="2.1" # Version number
06209efc
MT
28SLOGAN="www.ipfire.org" # Software slogan
29CONFIG_ROOT=/var/ipfire # Configuration rootdir
30NICE=10 # Nice level
31MAX_RETRIES=1 # prefetch/check loop
15679d9f
MT
32KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33MACHINE=`uname -m`
34SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
8f7b33ea 36IPFVER="full" # Which versions should be compiled? (full|devel)
03ad5f93
MT
37
38# Set an information about the build number
15679d9f
MT
39if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41fi
42
43# Debian specific settings
44if [ ! -e /etc/debian_version ]; then
df5e82b3 45 FULLPATH=`which $0`
15679d9f 46else
df5e82b3
MT
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
15679d9f 53fi
df5e82b3 54
15679d9f
MT
55PWD=`pwd`
56BASENAME=`basename $0`
57BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58LOGFILE=$BASEDIR/log/_build.preparation.log
59export BASEDIR LOGFILE
60DIR_CHK=$BASEDIR/cache/check
61mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 62
15679d9f
MT
63# Include funtions
64. tools/make-functions
df5e82b3 65
15679d9f
MT
66if [ -f .config ]; then
67 . .config
68else
6b8cff41
MT
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
15679d9f 76fi
df5e82b3
MT
77
78prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
1b273e8f 85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
df5e82b3
MT
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
1b273e8f 89 exiterror "Not running BASH shell."
df5e82b3
MT
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
9b0ff0a0 106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
df5e82b3
MT
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
1b273e8f
MT
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
15679d9f 111 else
1b273e8f 112 beautify message DONE
df5e82b3
MT
113 fi
114
15679d9f 115
df5e82b3
MT
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
9b0ff0a0 121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
df5e82b3 122 if [ `id -u` != 0 ]; then
1b273e8f
MT
123 beautify message FAIL
124 exiterror "Not building as root"
15679d9f 125 else
1b273e8f 126 beautify message DONE
df5e82b3
MT
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
9b0ff0a0 135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
df5e82b3
MT
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
41921bd9 138 if (( 2048000 > $BASE_ASPACE )); then
1b273e8f
MT
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
15679d9f 144 else
1b273e8f 145 beautify message DONE
df5e82b3
MT
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
df5e82b3
MT
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
1b273e8f 164 ln -s $BASEDIR/build/tools /
df5e82b3
MT
165 fi
166 if [ ! -h /tools ]; then
1b273e8f 167 exiterror "Could not create /tools symbolic link."
df5e82b3
MT
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
1179dc27 173 MAKETUNING="-j6"
dd714b8a 174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
df5e82b3
MT
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
90d372c4 179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
df5e82b3 180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
90d372c4
MT
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
df5e82b3
MT
185
186 # Make all sources and proc available under lfs build
90d372c4 187 mount --bind /dev $BASEDIR/build/dev
857d9bf2
MT
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
df5e82b3
MT
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
119ee469 202 # This is a temporary hack!!!
6b8cff41
MT
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
119ee469 206
df5e82b3
MT
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213}
214
df5e82b3
MT
215buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
df5e82b3
MT
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
15679d9f
MT
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
df5e82b3 224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
dd714b8a
MT
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
9b0ff0a0 227 lfsmake1 cleanup-toolchain PASS=1
df5e82b3
MT
228 lfsmake1 tcl
229 lfsmake1 expect
df5e82b3 230 lfsmake1 dejagnu
15679d9f
MT
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
dd714b8a
MT
233 lfsmake1 ncurses
234 lfsmake1 bash
df5e82b3 235 lfsmake1 bzip2
dd714b8a 236 lfsmake1 coreutils
df5e82b3
MT
237 lfsmake1 diffutils
238 lfsmake1 findutils
dd714b8a 239 lfsmake1 gawk
df5e82b3 240 lfsmake1 gettext
dd714b8a
MT
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
df5e82b3 245 lfsmake1 patch
dd714b8a
MT
246 lfsmake1 perl
247 lfsmake1 sed
df5e82b3
MT
248 lfsmake1 tar
249 lfsmake1 texinfo
df5e82b3 250 lfsmake1 util-linux
9b0ff0a0 251 lfsmake1 cleanup-toolchain PASS=2
df5e82b3
MT
252 export PATH=$ORG_PATH
253}
254
255buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
df5e82b3 258 lfsmake2 stage2
9b0ff0a0 259 lfsmake2 linux-libc-header
df5e82b3
MT
260 lfsmake2 man-pages
261 lfsmake2 glibc
9b0ff0a0 262 lfsmake2 cleanup-toolchain PASS=3
df5e82b3
MT
263 lfsmake2 binutils
264 lfsmake2 gcc
9b0ff0a0 265 lfsmake2 berkeley
df5e82b3 266 lfsmake2 coreutils
df5e82b3 267 lfsmake2 iana-etc
df5e82b3
MT
268 lfsmake2 m4
269 lfsmake2 bison
9b0ff0a0
MT
270 lfsmake2 ncurses
271 lfsmake2 procps
df5e82b3 272 lfsmake2 sed
9b0ff0a0 273 lfsmake2 libtool
df5e82b3 274 lfsmake2 perl
9b0ff0a0
MT
275 lfsmake2 readline
276 lfsmake2 zlib
df5e82b3
MT
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
df5e82b3
MT
280 lfsmake2 bzip2
281 lfsmake2 diffutils
df5e82b3 282 lfsmake2 e2fsprogs
65998e0a 283 lfsmake2 ed
9b0ff0a0
MT
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
9b0ff0a0
MT
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
df5e82b3 291 lfsmake2 gzip
9b0ff0a0
MT
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
44254afd 296 lfsmake2 libaal
df5e82b3 297 lfsmake2 make
9b0ff0a0
MT
298 lfsmake2 man
299 lfsmake2 mktemp
df5e82b3 300 lfsmake2 modutils
65f8f30f 301 lfsmake2 mtd
65998e0a 302 lfsmake2 net-tools
df5e82b3 303 lfsmake2 patch
df5e82b3 304 lfsmake2 psmisc
44254afd 305 lfsmake2 reiser4progs
df5e82b3
MT
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
90d372c4
MT
310 lfsmake2 texinfo
311 lfsmake2 udev
df5e82b3 312 lfsmake2 util-linux
90d372c4 313 lfsmake2 vim
44254afd 314 lfsmake2 grub
df5e82b3
MT
315}
316
15679d9f 317buildipfire() {
907cd036 318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 319 export LOGFILE
15679d9f 320 ipfiremake configroot
dc8b9670 321 ipfiremake backup
15679d9f
MT
322 ipfiremake dhcp
323 ipfiremake dhcpcd
324 ipfiremake libusb
325 ipfiremake libpcap
15679d9f
MT
326 ipfiremake ppp
327 ipfiremake rp-pppoe
328 ipfiremake unzip
3a1019f6 329 ipfiremake linux SMP=1
552b817b 330 ipfiremake ipp2p SMP=1
dd001658 331 ipfiremake zaptel SMP=1
c3e36980 332 ipfiremake linux
552b817b 333 ipfiremake ipp2p
119f6ad3 334 ipfiremake zaptel
c545beb1 335 ipfiremake pkg-config
a89770fa 336 ipfiremake linux-atm
ad9d4caf 337 ipfiremake cpio
ee78a5ef
MT
338 ipfiremake klibc
339 ipfiremake mkinitcpio
340 ipfiremake udev KLIBC=1
15679d9f
MT
341 ipfiremake expat
342 ipfiremake gdbm
343 ipfiremake gmp
c8ead4a5 344 ipfiremake pam
15679d9f 345 ipfiremake openssl
eac942d9 346 ipfiremake curl
15679d9f
MT
347 ipfiremake python
348 ipfiremake libnet
27b8cc24 349 ipfiremake libidn
ddac6087 350 ipfiremake libjpeg
15679d9f
MT
351 ipfiremake libpng
352 ipfiremake libtiff
fd3e7da0 353 ipfiremake libart
9594506f 354 ipfiremake freetype
15679d9f
MT
355 ipfiremake gd
356 ipfiremake popt
411afd1f 357 ipfiremake pcre
15679d9f
MT
358 ipfiremake slang
359 ipfiremake newt
fd3e7da0 360 ipfiremake libcap
15679d9f 361 ipfiremake pciutils
51f3b7f5 362 ipfiremake usbutils
15679d9f 363 ipfiremake libxml2
c6c9630e 364 ipfiremake libxslt
6b8cff41 365 ipfiremake BerkeleyDB
15679d9f 366 ipfiremake mysql
411afd1f 367 ipfiremake cyrus-sasl
15679d9f
MT
368 ipfiremake openldap
369 ipfiremake apache2
370 ipfiremake php
a10ae6cc 371 ipfiremake apache2 PASS=C
15679d9f
MT
372 ipfiremake arping
373 ipfiremake beep
374 ipfiremake bind
15679d9f
MT
375 ipfiremake cdrtools
376 ipfiremake dnsmasq
377 ipfiremake dosfstools
444973a4 378 ipfiremake squashfstools
72d80898 379 ipfiremake reiserfsprogs
93afd047 380 ipfiremake sysfsutils
8e055e65 381 ipfiremake fuse
d02350a2 382 ipfiremake ntfs-3g
15679d9f
MT
383 ipfiremake ethtool
384 ipfiremake ez-ipupdate
385 ipfiremake fcron
e3670217 386 ipfiremake perl-GD
330345c2 387 ipfiremake GD-Graph
786f2c8a 388 ipfiremake GD-TextUtil
15679d9f
MT
389 ipfiremake gnupg
390 ipfiremake hdparm
f9956330 391 ipfiremake sdparm
7861f575 392 ipfiremake mtools
15679d9f 393 ipfiremake initscripts
406f019f 394 ipfiremake whatmask
15679d9f 395 ipfiremake iptables
490256d5 396 ipfiremake libupnp
552b817b 397 ipfiremake ipp2p IPT=1
490256d5 398 ipfiremake linux-igd
15679d9f
MT
399 ipfiremake ipac-ng
400 ipfiremake ipaddr
15679d9f 401 ipfiremake iptstate
fd3e7da0 402 ipfiremake iputils
15679d9f 403 ipfiremake l7-protocols
8bba2965 404 ipfiremake mISDN
93afd047 405 ipfiremake hwdata
72d80898 406 ipfiremake kudzu
15679d9f
MT
407 ipfiremake logrotate
408 ipfiremake logwatch
15679d9f 409 ipfiremake misc-progs
15679d9f 410 ipfiremake nano
15679d9f
MT
411 ipfiremake nasm
412 ipfiremake URI
413 ipfiremake HTML-Tagset
414 ipfiremake HTML-Parser
415 ipfiremake Compress-Zlib
416 ipfiremake Digest
417 ipfiremake Digest-SHA1
418 ipfiremake Digest-HMAC
419 ipfiremake libwww-perl
420 ipfiremake Net-DNS
421 ipfiremake Net-IPv4Addr
422 ipfiremake Net_SSLeay
423 ipfiremake IO-Stringy
424 ipfiremake Unix-Syslog
425 ipfiremake Mail-Tools
426 ipfiremake MIME-Tools
427 ipfiremake Net-Server
428 ipfiremake Convert-TNEF
429 ipfiremake Convert-UUlib
430 ipfiremake Archive-Tar
431 ipfiremake Archive-Zip
432 ipfiremake Text-Tabs+Wrap
433 ipfiremake Locale-Country
93afd047 434 ipfiremake XML-Parser
c5568d64 435 ipfiremake glib
15679d9f
MT
436 ipfiremake GeoIP
437 ipfiremake fwhits
438 ipfiremake noip_updater
439 ipfiremake ntp
15679d9f
MT
440 ipfiremake openssh
441 ipfiremake openswan
15679d9f
MT
442 ipfiremake rrdtool
443 ipfiremake setserial
444 ipfiremake setup
445 ipfiremake snort
8a5604bf 446 ipfiremake oinkmaster
15679d9f
MT
447 ipfiremake squid
448 ipfiremake squid-graph
449 ipfiremake squidguard
069ae085 450 ipfiremake calamaris
6f00de0d 451 ipfiremake tcpdump
15679d9f
MT
452 ipfiremake traceroute
453 ipfiremake vlan
454 ipfiremake wireless
455 ipfiremake libsafe
15679d9f 456 ipfiremake pakfire
15679d9f 457 ipfiremake java
15679d9f
MT
458 ipfiremake spandsp
459 ipfiremake lzo
460 ipfiremake openvpn
15679d9f 461 ipfiremake pammysql
15679d9f 462 ipfiremake cups
fccb3371
MT
463 ipfiremake ghostscript
464 ipfiremake foomatic
2231d107 465 ipfiremake hplip
15679d9f
MT
466 ipfiremake samba
467 ipfiremake sudo
468 ipfiremake mc
469 ipfiremake wget
15679d9f
MT
470 ipfiremake bridge-utils
471 ipfiremake screen
472 ipfiremake hddtemp
473 ipfiremake smartmontools
474 ipfiremake htop
15679d9f 475 ipfiremake postfix
15679d9f 476 ipfiremake fetchmail
5ad5a6bc 477 ipfiremake cyrus-imapd
58493e1e 478 ipfiremake openmailadmin
15679d9f 479 ipfiremake clamav
15679d9f 480 ipfiremake spamassassin
fd3e7da0 481 ipfiremake amavisd
0708852c 482 ipfiremake alsa
15679d9f 483 ipfiremake mpg123
a28fdc01 484 ipfiremake mpfire
6c98857b 485 ipfiremake guardian
67081922 486 ipfiremake libid3tag
15679d9f
MT
487 ipfiremake libmad
488 ipfiremake libogg
489 ipfiremake libvorbis
490 ipfiremake lame
15679d9f 491 ipfiremake sox
a6931e7e 492 ipfiremake libshout
0dde24fa
MT
493 ipfiremake icecast
494 ipfiremake icegenerator
71043200 495 ipfiremake mpd
f86b0cc3 496 ipfiremake mpc
0dde24fa
MT
497 ipfiremake xvid
498 ipfiremake libmpeg2
499 ipfiremake videolan
0708852c 500 ipfiremake libpri
0708852c 501 ipfiremake asterisk
15679d9f 502 ipfiremake gnump3d
eac942d9 503 ipfiremake libsigc++
15679d9f
MT
504 ipfiremake applejuice
505 ipfiremake ocaml
506 ipfiremake mldonkey
eac942d9
MT
507 ipfiremake libtorrent
508 ipfiremake rtorrent
06209efc 509 ipfiremake ipfireseeder
15679d9f
MT
510 ipfiremake rsync
511 ipfiremake tcpwrapper
512 ipfiremake portmap
513 ipfiremake nfs
514 ipfiremake nmap
515 ipfiremake mbmon
15679d9f 516 ipfiremake ncftp
15679d9f 517 ipfiremake etherwake
06da1292 518 ipfiremake bwm-ng
1a8688ba
MT
519 ipfiremake tripwire
520 ipfiremake sysstat
a08c3a2e 521 ipfiremake vsftpd
51f3b7f5 522 ipfiremake which
186e3d2c 523 ipfiremake lsof
c5e5a5aa 524 ipfiremake centerim
d83f547d 525 ipfiremake br2684ctl
df5e82b3
MT
526}
527
528buildinstaller() {
529 # Run installer scripts one by one
530 LOGFILE="$BASEDIR/log/_build.installer.log"
531 export LOGFILE
0afc6d83 532 ipfiremake syslinux
4dc82852
MT
533 ipfiremake as86
534 ipfiremake mbr
fd0763dc 535 ipfiremake memtest
bc9f0c12
MT
536 installmake linux-libc-header
537 installmake binutils
538 ipfiremake uClibc PASS=1
539 ipfiremake gcc INST=1
540 installmake uClibc PASS=2
541 installmake gcc INST=2
542 installmake uClibc PASS=3
df5e82b3 543 installmake busybox
c66941dd 544 installmake udev
33634aa8
MT
545 installmake slang
546 installmake newt
72d80898 547 installmake gettext
33634aa8
MT
548 installmake kbd
549 installmake popt
33634aa8 550 installmake sysvinit
df5e82b3 551 installmake misc-progs
44254afd
MT
552 installmake libaal
553 installmake reiser4progs
89069053 554 installmake reiserfsprogs
a6316ce4 555 installmake sysfsutils
df5e82b3 556 installmake util-linux
df5e82b3 557 installmake pciutils
c5568d64 558 installmake zlib
65f8f30f 559 installmake mtd
c78a77eb 560 installmake wget
93afd047 561 installmake hwdata
fcb5057d 562 installmake kudzu
df5e82b3 563 installmake installer
df5e82b3 564 installmake initrd
df5e82b3
MT
565}
566
567buildpackages() {
568 LOGFILE="$BASEDIR/log/_build.packages.log"
569 export LOGFILE
570 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 571
edd536b6 572 installmake strip
df5e82b3
MT
573
574 # Generating list of packages used
0fbb45e9 575 echo -n "Generating packages list from logs" | tee -a $LOGFILE
df5e82b3
MT
576 rm -f $BASEDIR/doc/packages-list
577 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
578 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 579 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
580 fi
581 done
7471f6ab 582 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
4fe9acb2 583 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
df5e82b3
MT
584 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
585 rm -f $BASEDIR/doc/packages-list
c9673262 586 # packages-list.txt is ready to be displayed for wiki page
0fbb45e9 587 beautify message DONE
df5e82b3 588
9607771a 589 # Create images for install
74dbbc36
MT
590 ipfiremake cdrom ED=full
591
4dc82852 592 # Check if there is a loop device for building in virtual environments
eedc26d9 593 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
4dc82852
MT
594 ipfiremake usb-stick
595 fi
4dc82852 596 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
c9673262 597
0d909a4a 598 ipfirepackages
e67a57fe
MT
599
600 # Cleanup
601 stdumount
602 rm -rf $BASEDIR/build/tmp/*
603
604 # Generating total list of files
0d909a4a 605 echo -n "Generating files list from logs" | tee -a $LOGFILE
e67a57fe
MT
606 rm -f $BASEDIR/log/FILES
607 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
608 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
609 echo "##" >>$BASEDIR/log/FILES
610 echo "## `basename $i`" >>$BASEDIR/log/FILES
611 echo "##" >>$BASEDIR/log/FILES
612 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
613 fi
614 done
0d909a4a 615 beautify message DONE
e67a57fe
MT
616
617 cd $PWD
e67a57fe
MT
618}
619
620ipfirepackages() {
a5997a4c 621 ipfiremake core-updates
fe7fe395 622 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
453b418b
MT
623 if [ -e $BASEDIR/lfs/$i ]; then
624 ipfiredist $i
625 else
626 echo -n $i
627 beautify message SKIP
628 fi
fe7fe395 629 done
78331e30 630 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
5c8cfc99 631 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 632 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
633}
634
635# See what we're supposed to do
636case "$1" in
637build)
9729e787 638 clear
df5e82b3 639 BUILDMACHINE=`uname -m`
712d859c 640 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
df5e82b3 641 #only restore on a clean disk
9b0ff0a0 642 if [ ! -f log/cleanup-toolchain-2-tools ]; then
df5e82b3 643 if [ ! -n "$PACKAGE" ]; then
15679d9f 644 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
df5e82b3
MT
645 prepareenv
646 buildtoolchain
647 else
648 PACKAGENAME=${PACKAGE%.tar.gz}
15679d9f 649 beautify build_stage "Packaged toolchain compilation"
df5e82b3
MT
650 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
651 tar zxf $PACKAGE
652 prepareenv
653 else
654 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
655 fi
656 fi
657 else
9729e787
MT
658 echo -n "Using installed toolchain" | tee -a $LOGFILE
659 beautify message SKIP
df5e82b3
MT
660 prepareenv
661 fi
5cfe86e6 662
7ab7a9b4 663 beautify build_start
0b59f25c 664 beautify build_stage "Building LFS"
df5e82b3 665 buildbase
15679d9f 666
0b59f25c 667 beautify build_stage "Building IPFire"
15679d9f 668 buildipfire
5cfe86e6
HS
669
670 # Setzen des IPFire Builds
8af06406 671 if [ "$FIREBUILD" ]; then
e57bc1fd 672 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6 673 else
e57bc1fd 674 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6
HS
675 fi
676
0b59f25c 677 beautify build_stage "Building installer"
df5e82b3 678 buildinstaller
15679d9f 679
0b59f25c 680 beautify build_stage "Building packages"
df5e82b3 681 buildpackages
7ab7a9b4 682 beautify build_end
df5e82b3
MT
683 ;;
684shell)
685 # enter a shell inside LFS chroot
686 # may be used to changed kernel settings
687 prepareenv
688 entershell
689 ;;
690changelog)
d1dd6669 691 echo -n "Loading new Changelog from SVN: "
223ad6a4 692 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
a50d04ab 693 beautify message DONE
df5e82b3 694 ;;
df5e82b3 695clean)
a50d04ab 696 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
df5e82b3
MT
697 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
698 $LOSETUP -d $i 2>/dev/null
699 done
700 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
701 umount $i
702 done
703 stdumount
704 for i in `seq 0 7`; do
705 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
706 umount /dev/loop${i} 2>/dev/null;
707 losetup -d /dev/loop${i} 2>/dev/null;
708 fi;
709 done
710 rm -rf $BASEDIR/build
711 rm -rf $BASEDIR/cdrom
f9315063 712 rm -rf $BASEDIR/packages
df5e82b3 713 rm -rf $BASEDIR/log
df5e82b3
MT
714 if [ -h /tools ]; then
715 rm -f /tools
716 fi
a50d04ab 717 beautify message DONE
df5e82b3 718 ;;
c3db995c 719downloadsrc)
df5e82b3
MT
720 if [ ! -d $BASEDIR/cache ]; then
721 mkdir $BASEDIR/cache
722 fi
723 mkdir -p $BASEDIR/log
857d9bf2 724 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
725 FINISHED=0
726 cd $BASEDIR/lfs
727 for c in `seq $MAX_RETRIES`; do
728 if (( FINISHED==1 )); then
729 break
730 fi
731 FINISHED=1
732 cd $BASEDIR/lfs
733 for i in *; do
734 if [ -f "$i" -a "$i" != "Config" ]; then
e22c7973 735 echo -ne "Loading $i"
df5e82b3
MT
736 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
737 if [ $? -ne 0 ]; then
e22c7973 738 beautify message FAIL
df5e82b3
MT
739 FINISHED=0
740 else
741 if [ $c -eq 1 ]; then
e22c7973 742 beautify message DONE
df5e82b3
MT
743 fi
744 fi
745 fi
746 done
747 done
e22c7973 748 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
749 ERROR=0
750 for i in *; do
751 if [ -f "$i" -a "$i" != "Config" ]; then
752 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
753 if [ $? -ne 0 ]; then
e22c7973
MT
754 echo -ne "MD5 difference in lfs/$i"
755 beautify message FAIL
df5e82b3
MT
756 ERROR=1
757 fi
758 fi
759 done
760 if [ $ERROR -eq 0 ]; then
e22c7973
MT
761 echo -ne "${BOLD}all files md5sum match${NORMAL}"
762 beautify message DONE
763 else
764 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
765 beautify message FAIL
df5e82b3 766 fi
e22c7973 767 cd - >/dev/null 2>&1
df5e82b3 768 ;;
df5e82b3 769toolchain)
9729e787 770 clear
df5e82b3 771 prepareenv
15679d9f 772 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
df5e82b3
MT
773 buildtoolchain
774 BUILDMACHINE=`uname -m`
775 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
712d859c
MT
776 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
777 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
df5e82b3
MT
778 build/{bin,etc,usr/bin,usr/local} \
779 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
780 log >> $LOGFILE
712d859c
MT
781 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
782 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
df5e82b3
MT
783 stdumount
784 ;;
785gettoolchain)
786 BUILDMACHINE=`uname -m`
787 # arbitrary name to be updated in case of new toolchain package upload
c6cb9d25 788 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
712d859c 789 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
5bd13f01 790 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
712d859c
MT
791 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
792 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
793 cd $BASEDIR/cache/toolchains
5bd13f01 794 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c
MT
795 if [ $? -ne 0 ]; then
796 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
40a4ea4c 797 else
712d859c
MT
798 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
799 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
800 else
801 exiterror "$PACKAGE.md5 did not match, check downloaded package"
802 fi
40a4ea4c 803 fi
712d859c
MT
804 else
805 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
806 fi
807 ;;
15679d9f 808othersrc)
ce56e927 809 prepareenv
15679d9f 810 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
ce56e927
MT
811 chroot $LFS /tools/bin/env -i HOME=/root \
812 TERM=$TERM PS1='\u:\w\$ ' \
813 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
814 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
815 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
816 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
15679d9f
MT
817 if [ $? -eq "0" ]; then
818 beautify message DONE
819 else
820 beautify message FAIL
821 fi
ce56e927
MT
822 stdumount
823 ;;
c6cb9d25
MT
824svn)
825 case "$2" in
826 update|up)
cc0e56be 827 # clear
15679d9f 828 echo -ne "Loading the latest source files...\n"
7471f6ab
MT
829 if [ $3 ]; then
830 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
831 else
832 svn update | tee -a $PWD/log/_build.svn.update.log
833 fi
15679d9f
MT
834 if [ $? -eq "0" ]; then
835 beautify message DONE
c6cb9d25 836 else
15679d9f 837 beautify message FAIL
c6cb9d25
MT
838 exit 1
839 fi
15679d9f 840 echo -ne "Writing the svn-info to a file"
c6cb9d25 841 svn info > $PWD/svn_status
15679d9f
MT
842 if [ $? -eq "0" ]; then
843 beautify message DONE
c6cb9d25 844 else
15679d9f 845 beautify message FAIL
c6cb9d25
MT
846 exit 1
847 fi
712d859c 848 chmod 755 $0
cc0e56be 849 exit 0
c6cb9d25
MT
850 ;;
851 commit|ci)
852 clear
6b8cff41
MT
853 if [ -f /usr/bin/mcedit ]; then
854 export EDITOR=/usr/bin/mcedit
73d9a908
MT
855 fi
856 if [ -f /usr/bin/nano ]; then
857 export EDITOR=/usr/bin/nano
6b8cff41
MT
858 fi
859 echo -ne "Selecting editor $EDITOR..."
860 beautify message DONE
d79b46cb 861 if [ -e /sbin/yast ]; then
028698e8
MT
862 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
863 $0 changelog
864 fi
d79b46cb 865 fi
8a5f0f44 866 update_langs
15679d9f 867 svn commit
c6cb9d25 868 $0 svn up
1065bfea
MT
869 if [ -n "$FTP_CACHE_URL" ]; then
870 $0 uploadsrc
871 fi
c6cb9d25
MT
872 ;;
873 dist)
7471f6ab
MT
874 if [ $3 ]; then
875 SVN_REVISION=$3
876 fi
877 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
878 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
879 exit 0
880 fi
881 echo -en "REV $SVN_REVISION: Downloading..."
223ad6a4
MT
882 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
883 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
884 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
15679d9f
MT
885 evaluate 1
886
7471f6ab
MT
887 echo -en "REV $SVN_REVISION: Compressing files..."
888 if [ -e ipfire-source/trunk/make.sh ]; then
889 chmod 755 ipfire-source/trunk/make.sh
890 fi
9dc02b38 891 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
15679d9f 892 evaluate 1
7471f6ab 893 echo -en "REV $SVN_REVISION: Cleaning up..."
c6cb9d25 894 rm ipfire-source/ -r
15679d9f 895 evaluate 1
7471f6ab 896 ;;
028698e8 897 diff|di)
1a8688ba 898 update_langs
15679d9f 899 echo -ne "Make a local diff to last svn revision"
c6cb9d25 900 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
15679d9f 901 evaluate 1
c6cb9d25 902 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
bf7c473f 903 svn status
c6cb9d25
MT
904 ;;
905 esac
f9315063 906 ;;
15679d9f
MT
907uploadsrc)
908 PWD=`pwd`
909 cd $BASEDIR/cache/
910 echo -e "Uploading cache to ftp server:"
fd1b8061 911 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
15679d9f 912 for i in *; do
fd1b8061
MT
913 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
914 grep -q $(basename $i) /tmp/ftplist
0eab8e84 915 if [ "$?" -ne "0" ]; then
fd1b8061
MT
916 echo -ne "$(basename $i)"
917 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
6fb8ec08 918 if [ "$?" -ne "0" ]; then
15679d9f 919 beautify message FAIL
0eab8e84
MT
920 fi
921 fi
922 done
6fb8ec08 923 rm -f /tmp/ftplist
15679d9f
MT
924 cd $PWD
925 exit 0
0eab8e84 926 ;;
cc0e56be 927upload)
b2c64f8c
MT
928 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
929 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
930 if [ -z $FTP_ISO_PORT ]; then
931 FTP_ISO_PORT=21
932 fi
933 cat <<EOF > .ftp-commands
de2c999d 934mkdir -p $FTP_ISO_PATH$SVN_REVISION
b2c64f8c 935mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
9dc02b38
MT
936quit
937EOF
b2c64f8c
MT
938 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
939 rm -f .ftp-commands
940
941 case "$2" in
942 iso)
943 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
944
8f55c54e 945 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
dff9df9d
MT
946 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
947 if [ -e "$i" ]; then
b2c64f8c
MT
948 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
949 if [ "$?" -eq "0" ]; then
950 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
951 else
952 echo "There was an error while uploading the file $i to the ftp server."
953 exit 1
954 fi
dff9df9d 955 fi
b2c64f8c 956 done
a4c9c660 957 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
6aae8d61 958 if [ "$3" = "--with-sources-cd" ]; then
b2c64f8c 959 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
6aae8d61 960 fi
cc0e56be
MT
961 ;;
962 paks)
b2c64f8c 963 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
cc0e56be 964 if [ "$?" -eq "0" ]; then
822c5bd0 965 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
cc0e56be
MT
966 else
967 echo -e "There was an error while uploading the packages to the ftp server."
712d859c 968 exit 1
cc0e56be
MT
969 fi
970 ;;
971 esac
0d0521b6 972 ;;
cc0e56be 973batch)
c8582074 974 if [ "$2" = "--background" ]; then
15679d9f
MT
975 batch_script
976 exit $?
977 fi
27ac55bf 978 if [ `screen -ls | grep -q ipfire` ]; then
712d859c
MT
979 echo "Build is already running, sorry!"
980 exit 1
981 else
27ac55bf
MT
982 if [ "$2" = "--rebuild" ]; then
983 export IPFIRE_REBUILD=1
984 echo "REBUILD!"
985 else
986 export IPFIRE_REBUILD=0
987 fi
15679d9f
MT
988 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
989 screen -dmS ipfire $0 batch --background
990 evaluate 1
712d859c
MT
991 exit 0
992 fi
cc0e56be 993 ;;
028698e8 994watch)
15679d9f 995 watch_screen
028698e8 996 ;;
33634aa8
MT
997pxe)
998 case "$2" in
999 start)
1000 start_tftpd
1001 ;;
1002 stop)
1003 stop_tftpd
1004 ;;
a50d04ab 1005 reload|restart)
33634aa8
MT
1006 reload_tftpd
1007 ;;
1008 esac
1009 exit 0
1010 ;;
bf7c473f
MT
1011lang)
1012 update_langs
1013 ;;
6b8cff41 1014"")
24a4a744
MT
1015 clear
1016 svn info
c3db995c 1017 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
24a4a744
MT
1018 do
1019 case $name in
c3db995c
MT
1020 "IPFIRE: Downloadsrc")
1021 $0 downloadsrc
c6cb9d25
MT
1022 ;;
1023 "IPFIRE: Build (silent)")
1024 $0 build-silent
1025 ;;
1026 "IPFIRE: Watch Build")
028698e8 1027 $0 watch
c6cb9d25 1028 ;;
712d859c
MT
1029 "IPFIRE: Batch")
1030 $0 batch
1031 ;;
c6cb9d25
MT
1032 "IPFIRE: Clean")
1033 $0 clean
1034 ;;
c6cb9d25
MT
1035 "SVN: Update")
1036 $0 svn update
1037 ;;
c6cb9d25 1038 "Help")
a50d04ab 1039 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
c6cb9d25
MT
1040 cat doc/make.sh-usage
1041 ;;
712d859c
MT
1042 "LOG: Tail")
1043 tail -f log/_*
1044 ;;
c6cb9d25
MT
1045 "Exit")
1046 break
1047 ;;
24a4a744
MT
1048 esac
1049 done
df5e82b3 1050 ;;
a50d04ab
MT
1051config)
1052 make_config
1053 ;;
6b8cff41 1054*)
a50d04ab 1055 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
6b8cff41
MT
1056 cat doc/make.sh-usage
1057 ;;
3ea75603 1058esac